; 
    include \masm32\include\masm32rt.inc
; 
.686p

comment * -----------------------------------------------------
                     Build this console app with
                  "MAKEIT.BAT" on the PROJECT menu.
        ----------------------------------------------------- *

    .data?
      value dd ?

    .data
      g_priorityClass textequ <REALTIME_PRIORITY_CLASS>

      ;item dd 0
      g_tallyBucketSize equ 256
      align 16
      tallyBucket dd 2*g_tallyBucketSize dup(0)

      runCache dd 128 dup(0)
      
    .code

start:
   
; 
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, g_priorityClass
    invoke GetCurrentThread
    invoke SetThreadPriority, eax, THREAD_PRIORITY_TIME_CRITICAL
    invoke  GetCurrentProcess
        invoke  SetProcessAffinityMask,eax,1
        invoke  Sleep,750
    invoke Sleep, 0
    call main
   ; inkey
    exit

; 

main proc
    mov ecx, 15
    l_spinup:
      call init_spinup
      call init_spinup
    dec ecx
    jns l_spinup
    
    cls
    mov ecx, 1000
l:
    call do_sample_run
    dec ecx
    jns l
    ret
main endp
    
do_sample_run proc
    push ecx
retry:
    ;invoke Sleep,0
    call spinup
    
    mov edi, 11
l:
    push edi
    call timeit
    mov [runCache+edi*4], eax
    pop edi
    dec edi
    jns l

    mov edi, 11
    mov eax, [runCache+edi*4]
l_check_equality:
    cmp [runCache+edi*4], eax
    jne retry
    dec edi
    jns l_check_equality

    push eax
    call print_number

    pop ecx
    ret
do_sample_run endp

;; Does not visibly change any registers.
;; Simply spins up the CPU in preperation of "real" timing tests.
init_spinup proc
    push ecx
    mov ecx, 10000000
l:
    dec ecx
    jns l
    pop ecx
    ret
init_spinup endp


;; Does not visibly change any registers.
;; Simply spins up the CPU in preperation of "real" timing tests.
spinup proc
    push ecx
    mov ecx, 100000
l:
    dec ecx
    jns l
    pop ecx
    ret
spinup endp



align 16
timeit proc
; warmup
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    rdtsc 
    ; now go for real!
    xor eax, eax
    cpuid
    rdtsc
    push eax
    push edx
    call testit
    xor eax, eax
    cpuid
    rdtsc
    push eax
    push edx
    call print_runtime
    ret

timeit endp

;;;;;;;;; code under test should go here! ;;;;;;;;;
testit proc
    ret
testit endp

print_runtime proc
    pop esi
    pop edx
    pop eax
    pop ecx
    ;sub edx, ecx
    cmp ecx, edx
    jne wraparound
    pop ecx
    sub eax, ecx
    push eax
    ;print ustr$(eax)
    ;print " ",13,10
    pop eax
    push esi
    ret
wraparound:
    mov eax, 0
    pop ecx
    push esi
    ret
    
print_runtime endp

print_number  proc
    pop esi
    pop eax
    print ustr$(eax)
    print " ",13,10
    push esi
    ret
print_number endp
; 

end start
